LD1	MACRO	DEST,OP		;DEST:=OP
	movff	OP,DEST
	ENDM
;
ADD1	MACRO	DEST,OP		;DEST:=DEST+OP
	movf	OP,W
	addwf	DEST,F
	ENDM
;
SUB1	MACRO	DEST,OP		;DEST:=DEST-OP
	movf	OP,W
	subwf	DEST,F
	ENDM

CMP1	MACRO	DEST,OP		;W:=DEST-OP
	movf	OP,W
	subwf	DEST,W
	ENDM
;
LDK1	MACRO	DEST,KL		;DEST:=KL
	movlw	KL
	movwf	DEST
	ENDM
;
ADDK1	MACRO	DEST,KL        ; DEST:=DEST+KL
	movlw	KL
	ADDWF     DEST
         ENDM
;
SUBK1    MACRO     DEST,KL        ; DEST:=DEST-KL
         MOVLW     KL
         SUBWF     DEST
         ENDM
;
NSUBK1   MACRO     DEST,KL        ; DEST:=KL-DEST
         MOVLW     DEST,W
         SUBLW     DEST            ;
         ENDM
;
;CMPK1    MACRO     DEST,KL        ; W:= DEST-W
;         MOVLW     KL
;         SUBWF     DEST,W
;         ENDM
;
CLR2     MACRO     DEST
         CLRF      DEST
         CLRF      DEST+1
         ENDM

LD2      MACRO     DEST,OP
         MOVFF     OP+1,DEST+1
         MOVFF     OP,DEST
         ENDM
;
DEC2     MACRO     DEST
         DECF      DEST,F
         INCF      DEST,W
	 SKPNZ
         DECF      DEST+1,F
         SKPNZ
	 MOVF	   DEST,F
	 ENDM

DEC3	MACRO	DEST
	LOCAL	DEC31
	DECF	DEST,F
	INCF	DEST,W
	SKPZ
	goto	DEC31
	DECF	DEST+1,F
	INCF	DEST+1,W
	SKPNZ
	DECF	DEST+2,F
DEC31:
	ENDM

DEC4     MACRO	DEST
	LOCAL	DEC41
         DECF	DEST,F
         INCF	DEST,W
         SKPZ
	goto	DEC41
         DECF	DEST+1,F
         INCF	DEST+1,W
         SKPZ
	goto	DEC41
         DECF	DEST+2,F
         INCF	DEST+2,W
         SKPNZ
         DECF	DEST+3,F
DEC41:
         ENDM

DEC5     MACRO	DEST
	LOCAL	DEC51
         DECF	DEST,F
         INCF	DEST,W
         SKPZ
	goto	DEC51
         DECF	DEST+1,F
         INCF	DEST+1,W
         SKPZ
	goto	DEC51
         DECF	DEST+2,F
         INCF	DEST+2,W
         SKPZ
	goto	DEC51
         DECF	DEST+3,F
         INCF	DEST+3,W
         SKPNZ
         DECF	DEST+4,F
DEC51:
         ENDM
;
INC2     MACRO     DEST
         INCF      DEST,F
         SKPNZ
         INCF      DEST+1,F
         ENDM

INC3     MACRO     DEST
	 INC2      DEST
         SKPNZ
         INCF      DEST+2,F
         ENDM

INC4     MACRO     DEST
	 INC3      DEST
         SKPNZ
         INCF      DEST+3,F
         ENDM

INC5     MACRO     DEST
	 INC4      DEST
         SKPNZ
         INCF      DEST+4,F
         ENDM

;
ADD2     MACRO     DEST,OP
         MOVF      OP,W
         ADDWF     DEST,F
         MOVF      OP+1,W
         ADDWFC    DEST+1,F
         ENDM
;
SUB2     MACRO     DEST,OP        ; Low Byte first
         MOVF      OP,W
         SUBWF     DEST,F
         MOVF      OP+1,W
         SKPC
         INCFSZ    OP+1,W
         SUBWF     DEST+1,F
         ENDM

NEG2      MACRO     DEST
          COMF      DEST,F
          COMF      DEST+1,F
          INCF      DEST,F
          SKPNZ
          INCF      DEST+1,F
          ENDM

NEG3	MACRO	DEST
	COMF	DEST,F
	COMF	DEST+1,F
	COMF	DEST+2,F
	INC3	DEST
	ENDM

NEG4	MACRO	DEST
	COMF	DEST,F
	COMF	DEST+1,F
	COMF	DEST+2,F
	COMF	DEST+3,F
	INC4	DEST
	ENDM

NEG5	MACRO	DEST
	COMF	DEST,F
	COMF	DEST+1,F
	COMF	DEST+2,F
	COMF	DEST+3,F
	COMF	DEST+4,F
	INC5	DEST
	ENDM

NSUB2    MACRO     DEST,OP        ; Low Byte first
         MOVF      DEST,W
         SUBWF     OP,W
         MOVWF     DEST,F
         MOVF      DEST+1,W
         SKPC
         INCFSZ    DEST+1,W
         SUBWF     OP+1,W
         MOVWF     DEST+1
         ENDM
;
CMP2     MACRO     DEST,OP        ; Low Byte first
         LOCAL     CEND
         MOVF      OP+1,W
         SUBWF     DEST+1,W
         SKPZ
         bra      CEND
         MOVF      OP,W
         SUBWF     DEST,W
CEND     NOP
         ENDM

CMP4     MACRO     DEST,OP        ; Low Byte first
         LOCAL     CEND
         MOVF      OP+3,W
         SUBWF     DEST+3,W
         SKPZ
         bra      CEND
         MOVF      OP+2,W
         SUBWF     DEST+2,W
         SKPZ
         bra      CEND
         MOVF      OP+1,W
         SUBWF     DEST+1,W
         SKPZ
         bra      CEND
         MOVF      OP,W
         SUBWF     DEST,W
CEND     NOP
         ENDM

CMP5     MACRO     DEST,OP        ; Low Byte first
         LOCAL     CEND
         MOVF      OP+4,W
         SUBWF     DEST+4,W
         SKPZ
         bra      CEND
         MOVF      OP+3,W
         SUBWF     DEST+3,W
         SKPZ
         bra      CEND
         MOVF      OP+2,W
         SUBWF     DEST+2,W
         SKPZ
         bra      CEND
         MOVF      OP+1,W
         SUBWF     DEST+1,W
         SKPZ
         bra      CEND
         MOVF      OP,W
         SUBWF     DEST,W
CEND     NOP
         ENDM


LDKWD	MACRO	DEST,K
	MOVLW	HIGH K
	MOVWF	DEST+1
	MOVLW	LOW K
	MOVWF	DEST
	ENDM

LDK2     MACRO     DEST,KH,KL
         MOVLW     KH
         MOVWF     DEST+1
         MOVLW     KL
         MOVWF     DEST
         ENDM
;
RL2      MACRO     DEST
         RLCF       DEST,F
         RLCF       DEST+1,F
         ENDM
;
RR2      MACRO     DEST
         RRCF       DEST+1,F
         RRCF       DEST,F
         ENDM
;
CLR3     MACRO     DEST
         CLRF      DEST
         CLRF      DEST+1
         CLRF      DEST+2
         ENDM

LD3      MACRO     DEST,OP
         LD2       DEST,OP
         MOVFF     OP+2,DEST+2
         ENDM

LD4      MACRO     DEST,OP
         LD3       DEST,OP
         MOVFF     OP+3,DEST+3
         ENDM

LD5      MACRO     DEST,OP
         LD4       DEST,OP
         MOVFF     OP+4,DEST+4
         ENDM

;
ADD3     MACRO     DEST,OP
         ADD2      DEST,OP
         MOVF      OP+2,W
         SKPNC
         INCFSZ    OP+2,W
         ADDWF     DEST+2,F
         ENDM
;
ADD4     MACRO     DEST,OP
         ADD3      DEST,OP
         MOVF      OP+3,W
         SKPNC
         INCFSZ    OP+3,W
         ADDWF     DEST+3,F
         ENDM
;
ADD5     MACRO     DEST,OP
         ADD4      DEST,OP
         MOVF      OP+4,W
         SKPNC
         INCFSZ    OP+4,W
         ADDWF     DEST+4,F
         ENDM
;
SUB3     MACRO     DEST,OP        ; Low Byte first
         SUB2      DEST,OP
         MOVF      OP+2,W
         SKPC
         INCFSZ    OP+2,W
         SUBWF     DEST+2,F
         ENDM
;
SUB4     MACRO     DEST,OP        ; Low Byte first
         SUB3      DEST,OP
         MOVF      OP+3,W
         SKPC
         INCFSZ    OP+3,W
         SUBWF     DEST+3,F
         ENDM
;
SUB5     MACRO     DEST,OP        ; Low Byte first
         SUB4      DEST,OP
         MOVF      OP+4,W
         SKPC
         INCFSZ    OP+4,W
         SUBWF     DEST+4,F
         ENDM
;
NSUB3    MACRO     DEST,OP        ; Low Byte first
         NSUB2     DEST,OP
         MOVF      DEST+2,W
         SKPC
         INCFSZ    DEST+2,W
         SUBWF     OP+2,W
         MOVWF     DEST+2
         ENDM
;
CMP3     MACRO     DEST,OP
         LOCAL     C2END
	 MOVF	   OP+2,W
	 SUBWF	   DEST+2,W
	 SKPZ
	 bra	   C2END
         CMP2      DEST,OP
C2END    NOP
         ENDM

RL3      MACRO     DEST
         RLCF       DEST
         RLCF       DEST+1
         RLCF       DEST+2
         ENDM
;
RR3      MACRO     DEST
         RRCF       DEST+2
         RRCF       DEST+1
         RRCF       DEST
         ENDM
;
CLR4     MACRO     DEST
         CLRF       DEST
         CLRF       DEST+1
         CLRF       DEST+2
         CLRF       DEST+3
         ENDM

CLR5     MACRO     DEST
         CLRF       DEST
         CLRF       DEST+1
         CLRF       DEST+2
         CLRF       DEST+3
         CLRF       DEST+4
         ENDM
;
RL4      MACRO     DEST
         RLCF       DEST,F
         RLCF       DEST+1,F
         RLCF       DEST+2,F
         RLCF       DEST+3,F
         ENDM

RL5      MACRO     DEST
         RLCF       DEST,F
         RLCF       DEST+1,F
         RLCF       DEST+2,F
         RLCF       DEST+3,F
         RLCF       DEST+4,F
         ENDM

RL6      MACRO     DEST
         RLCF       DEST,F
         RLCF       DEST+1,F
         RLCF       DEST+2,F
         RLCF       DEST+3,F
         RLCF       DEST+4,F
         RLCF       DEST+5,F
         ENDM
;
RR4      MACRO     DEST
         RRCF       DEST+3,F
         RRCF       DEST+2,F
         RRCF       DEST+1,F
         RRCF       DEST,F
         ENDM

RR5      MACRO     DEST
         RRCF       DEST+4,F
         RRCF       DEST+3,F
         RRCF       DEST+2,F
         RRCF       DEST+1,F
         RRCF       DEST,F
         ENDM
;
;
ADDK4    MACRO     DEST,KH2,KL2,KH1,KL1
         MOVLW     KL1
         ADDWF     DEST
         SKPNC
         INCF      DEST+1
         MOVLW     KH1
         ADDWF     DEST+1
         SKPNC
         INCF      DEST+2
         MOVLW     KL2
         ADDWF     DEST+2
         SKPNC
         INCF      DEST+3
         MOVLW     KH2
         ADDWF     DEST+3
         ENDM

BMUL10	MACRO	DEST
	MOVLW	.10
	MULWF	DEST
	MOVFF	PRODH,DEST+1
	MOVFF	PRODL,DEST
	ENDM

MOVLFBB macro  literal,dest,banka,bankb
	movlb	banka
        movlw  literal
        movwf  dest
	movlb	bankb
        endm

MOVLF   macro  literal,dest
        movlw  literal
        movwf  dest
        endm

POINT   macro  stringname
        MOVLF  upper stringname, TBLPTRU
        MOVLF  high stringname, TBLPTRH
        MOVLF  low stringname, TBLPTRL
        endm

LDK4     MACRO	DEST,KH1,KL1,KH2,KL2
         MOVLF	KH1,DEST+3
         MOVLF	KL1,DEST+2
         MOVLF	KH2,DEST+1
         MOVLF	KL2,DEST
         ENDM

LDK5     MACRO	DEST,KH1,KL1,KH2,KL2,KH3
         MOVLF	KH1,DEST+4
         MOVLF	KL1,DEST+3
         MOVLF	KH2,DEST+2
         MOVLF	KL2,DEST+1
         MOVLF	KH3,DEST
         ENDM

;;;;;;; Macro definitions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Stringausgabe aus Code auf RS232 ohne Position
rs232Str	macro	string
		POINT	string
		call	rs232String
		endm

;Stringausgabe aus Code auf LCD ohne Position
LCDStr	macro	string
	POINT	string
	call	LCDString
	endm

;Stringausgabe aus Code auf LCD mit Position
LCDStrp	macro	string
	POINT	string
	call	LCDStringp
	endm

;HEX-Ausgabe von 6ByteKonstande auf Zeile 1 
LCDHEX6Z1	macro	var1
	movlw	0
	call	LCDPos
	movf	var1+5,W
	call	LCDHEX
	movf	var1+4,W
	call	LCDHEX
	movf	var1+3,W
	call	LCDHEX
	movf	var1+2,W
	call	LCDHEX
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	endm

;HEX-Ausgabe von 5ByteKonstande auf Zeile 1 
LCDHEX5Z1	macro	var1
	movlw	0
	call	LCDPos
	movf	var1+4,W
	call	LCDHEX
	movf	var1+3,W
	call	LCDHEX
	movf	var1+2,W
	call	LCDHEX
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	call	LCDSpace
	endm

;HEX-Ausgabe von einem DWord auf Zeile 1 
LCDHEX4Z1	macro	var1
	movlw	0
	call	LCDPos
	movf	var1+3,W
	call	LCDHEX
	movf	var1+2,W
	call	LCDHEX
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	call	LCDSpace
	endm

;HEX-Ausgabe von einem DWord auf Zeile 2
LCDHEX4Z2	macro	var1
	movlw	40h
	call	LCDPos
	movf	var1+3,W
	call	LCDHEX
	movf	var1+2,W
	call	LCDHEX
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	call	LCDSpace
	endm

;HEX-Ausgabe von einem Word auf Zeile 1
LCDHEX2Z1	macro	var1
	movlw	0
	call	LCDPos
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	call	LCDSpace
	endm

;HEX-Ausgabe von einem Word auf Zeile 2
LCDHEX2Z2	macro	var1
	movlw	40h
	call	LCDPos
	movf	var1+1,W
	call	LCDHEX
	movf	var1,W
	call	LCDHEX
	call	LCDSpace
	endm

MOVWDF	macro	literal,dest
	movlw	LOW literal
	movwf	dest
	movlw	HIGH literal
	movwf	dest+1
	endm

CMPK1	MACRO     DEST,KL        ; W:= DEST-W
	MOVLW     KL
	SUBWF     DEST,W
	ENDM

CMPK2	MACRO	DEST,wert	; Low Byte first
	LOCAL	CEND
	MOVLW	HIGH wert
	SUBWF	DEST+1,W
	SKPZ
	GOTO	CEND
	MOVLW	LOW wert
	SUBWF	DEST,W
CEND	NOP
	ENDM

FGLL1	MACRO	wert, freg
	movlw	wert
	cpfseq	freg
	ENDM

FGRL1	MACRO	wert, freg
	movlw	wert
	cpfsgt	freg
	ENDM

FKLL1	MACRO	wert, freg
	movlw	wert
	cpfslt	freg
	ENDM
